package com.mt.wms.empty.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.mt.wms.core.api.Assert;
import com.mt.wms.core.base.BaseService;
import com.mt.wms.core.dal.entity.CurrTask;
import com.mt.wms.core.dal.service.CurrTaskServiceBiz;
import com.mt.wms.core.params.IdParam;
import com.mt.wms.core.vo.IdVo;
import com.mt.wms.core.vo.PageVo;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.enums.TaskTypeEnum;
import com.mt.wms.empty.params.CurrTaskQueryParam;
import com.mt.wms.empty.params.TaskCreateParam;
import com.mt.wms.empty.service.CurrTaskDetService;
import com.mt.wms.empty.service.CurrTaskService;
import com.mt.wms.empty.vo.CurrTaskQueryVo;
import com.mt.wms.empty.vo.CurrTaskVo;
import org.apache.commons.codec.net.QCodec;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * xx服务实现类
 *
 * @author xcc
 * @date 2021年11月8日
 * @since 1.0
 */
@Service
@Transactional
public class CurrTaskServiceImpl extends BaseService implements CurrTaskService {

    @Autowired
    CurrTaskServiceBiz currTaskServiceBiz;

    @Autowired
    CurrTaskDetService currTaskDetService;

    @Override
    public CurrTaskVo getCurrTask(IdParam idParam) {
        CurrTask byId = currTaskServiceBiz.getById(idParam.getId());
        CurrTaskVo build = CurrTaskVo.builder().build();
        BeanUtils.copyProperties(byId,build);
        return build;
    }

    @Override
    public R<IdVo> createFirstTask(TaskCreateParam param) {
        CurrTask currTask = new CurrTask();
        currTask.setStartPosition(param.getStartPosition());
        currTask.setTargetPosition(param.getTargetPosition());
        currTask.setKilnId(param.getKilnId());
        currTask.setTaskType(TaskTypeEnum.WTK.getValue());
        currTask.setPalletCode(param.getPalletCode());
        currTask.setTaskSource(0);
        setCommonField(currTask);
        currTaskServiceBiz.save(currTask);
        return successful(IdVo.builder().id(currTask.getId()).build());
    }

    @Override
    public R<PageVo<CurrTaskQueryVo>> currentTaskPage(CurrTaskQueryParam param) {
        QueryWrapper<CurrTask> currTaskQueryWrapper= new QueryWrapper<>();
        currTaskQueryWrapper.eq(StringUtils.isNotBlank(param.getVehicleId()),CurrTask.VEHICLE_ID,param.getVehicleId());
        currTaskQueryWrapper.eq(CurrTask.VALID,1);
        Page<CurrTask> page = currTaskServiceBiz.page(new Page<>(param.getCurrent(), param.getSize()), currTaskQueryWrapper);
        return successful(new PageVo<>(page,CurrTaskQueryVo.class));
    }
}
